unit downcount;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Qt, ExtCtrls;

type
  TMainForm = class(TForm)
    LabHH: TLabel;
    LabMM: TLabel;
    LabSS: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    BtnStart: TSpeedButton;
    TimerSec: TTimer;
    TimerBeep: TTimer;
    BtnClear: TSpeedButton;
    CBTop: TCheckBox;
    CBMute: TCheckBox;
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BtnStartClick(Sender: TObject);
    procedure TimerSecTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TimerBeepTimer(Sender: TObject);
    procedure BtnClearClick(Sender: TObject);
    //procedure BtnTopClick(Sender: TObject);
    procedure CBTopClick(Sender: TObject);
    procedure CBTopKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CBMuteKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

var H1,H0: Word;
var M1,M0: Word;
var S1,S0: Word;
var TotalSecs : Longword;
var PreTotalSecs : Longword;
var TimerInProg : Word;
var BeepInProg : Word;
var BeepCount : Word;
var FormTop : Word;

{$R *.dfm}
procedure  CaptureKey(var Key: Word);
begin
    //Don't allow enter while beeping or Count is in progress
    if (BeepInProg=0)and(TimerInProg=0) then
    begin
        if Key in [Key_0..Key_9] then
        begin
          if PreTotalSecs > 0 then
          begin
            PreTotalSecs := 0;
            H1 := 0;
            H0 := 0;
            M1 := 0;
            M0 := 0;
            S1 := 0;
            S0 := 0;
          end;
            H1 := H0;
            H0 := M1;
            M1 := M0;
            M0 := S1;
            S1 := S0;
            S0 := Key - 48;

            MainForm.LabHH.Caption := InttoStr(H1) + InttoStr(H0);
            MainForm.LabMM.Caption := InttoStr(M1) + InttoStr(M0);
            MainForm.LabSS.Caption := InttoStr(S1) + InttoStr(S0);
        end
        else if Key = 13 then        //if Enter
        begin
            if (PreTotalSecs = 0) then
              TotalSecs := (H1*10 + H0)*3600 + (M1*10 + M0)*60 + S1*10 + S0
            else
              TotalSecs := PreTotalSecs;

            if TotalSecs > 0 then
            begin
                PreTotalSecs := TotalSecs;
                MainForm.TimerSec.Enabled := True;
                MainForm.BtnStart.Caption := 'STP';
                TimerInProg := 1;
            end
            else
            begin
                Application.MessageBox('The Time value should greater than 0! Please enter the time and press Start', 'Warning!', MB_OK);
            end;
        end
    end;
end;

procedure TMainForm.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  CaptureKey( Key);
end;

procedure TMainForm.BtnStartClick(Sender: TObject);
begin
    if BeepInProg = 0 then
    begin
        if TimerInProg = 1 then
        begin
            TimerSec.Enabled := False;
            BtnStart.Caption := 'RUN';
            TimerInProg := 0;

            TotalSecs := PreTotalSecs;
            H1 := TotalSecs div 3600;
            H0 := H1 mod 10;
            H1 := H1 div 10;

            M1 := (TotalSecs mod 3600) div 60;
            M0 := M1 mod 10;
            M1 := M1 div 10;

            S1 := TotalSecs mod 60;
            S0 := S1 mod 10;
            S1 := S1 div 10;

            LabHH.Caption := InttoStr(H1) + InttoStr(H0);
            LabMM.Caption := InttoStr(M1) + InttoStr(M0);
            LabSS.Caption := InttoStr(S1) + InttoStr(S0);
        end
        else if TimerInProg = 0 then
        begin
            //TotalSecs := (H1*10 + H0)*3600 + (M1*10 + M0)*60 + S1*10 + S0;
            if (PreTotalSecs = 0) then
              TotalSecs := (H1*10 + H0)*3600 + (M1*10 + M0)*60 + S1*10 + S0
            else
              TotalSecs := PreTotalSecs;

            if TotalSecs > 0 then
            begin
                PreTotalSecs := TotalSecs;
                TimerSec.Enabled := True;
                BtnStart.Caption := 'STP';
                TimerInProg := 1;
            end
            else
            begin
                Application.MessageBox('The Time value should greater than 0! Please enter the time and press Start', 'Warning!', MB_OK);
            end;

        end
    end
    else if BeepInProg = 1 then
    begin
        TimerBeep.Enabled := False;
        BeepInProg := 0;
        BtnStart.Caption := 'RUN';
        MainForm.FormStyle := fsNormal;
        //MainForm.BtnStart.Font.Color := clActiveCaption;
        MainForm.Color := ClBtnFace
    end;
end;

procedure TMainForm.TimerSecTimer(Sender: TObject);
begin
    TotalSecs := TotalSecs - 1;

    if TotalSecs > 0 then
    begin
        TimerSec.Enabled := True;
        H1 := TotalSecs div 3600;
        H0 := H1 mod 10;
        H1 := H1 div 10;

        M1 := (TotalSecs mod 3600) div 60;
        M0 := M1 mod 10;
        M1 := M1 div 10;

        S1 := TotalSecs mod 60;
        S0 := S1 mod 10;
        S1 := S1 div 10;

        LabHH.Caption := InttoStr(H1) + InttoStr(H0);
        LabMM.Caption := InttoStr(M1) + InttoStr(M0);
        LabSS.Caption := InttoStr(S1) + InttoStr(S0);
    end
    else if TotalSecs = 0 then
    begin
        TimerSec.Enabled := False;
        TimerInProg := 0;

        TotalSecs := PreTotalSecs;
        H1 := TotalSecs div 3600;
        H0 := H1 mod 10;
        H1 := H1 div 10;

        M1 := (TotalSecs mod 3600) div 60;
        M0 := M1 mod 10;
        M1 := M1 div 10;

        S1 := TotalSecs mod 60;
        S0 := S1 mod 10;
        S1 := S1 div 10;

        LabHH.Caption := InttoStr(H1) + InttoStr(H0);
        LabMM.Caption := InttoStr(M1) + InttoStr(M0);
        LabSS.Caption := InttoStr(S1) + InttoStr(S0);

        //start the beep timer
        //will not stop beep till click the stop button
        TimerBeep.Enabled := True;
        if FormTop=0 then
        begin
          FormTop := 1;
          //BtnTop.Caption := 'NOR';
          CBTop.Checked := True;
          SetWindowPos(MainForm.Handle,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE or SWP_NOSIZE);
        end;
        //MainForm.FormStyle := fsStayOnTop;
        BeepInProg := 1;
    end;

end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
    TimerInProg := 0;
    BeepInProg := 0;
    H1 := 0;
    H0 := 0;
    M1 := 0;
    M0 := 0;
    S1 := 0;
    S0 := 0;
    BeepCount := 0;
    TotalSecs := 0;
    PreTotalSecs := 0;
    FormTop := 0;
end;

procedure TMainForm.TimerBeepTimer(Sender: TObject);
begin
  if CBMute.Checked=False then
   windows.Beep(1000,165);

   BeepCount := BeepCount + 1;
   if (BeepCount mod 4)=0 then
        //BtnStart.Font.Color := clActiveCaption
        MainForm.Color := ClBtnFace
   else if (BeepCount mod 2)=0 then
        //BtnStart.Font.Color := clRed;
        MainForm.Color := ClRed;

   if BeepCount > 6400 then
    BeepCount := 0;
end;

procedure TMainForm.BtnClearClick(Sender: TObject);
begin
    TimerSec.Enabled := False;
    TimerInProg := 0;
    H1 := 0;
    H0 := 0;
    M1 := 0;
    M0 := 0;
    S1 := 0;
    S0 := 0;
    LabHH.Caption := '00';
    LabMM.Caption := '00';
    LabSS.Caption := '00';
    TotalSecs := 0;
    PreTotalSecs := 0;
    TimerBeep.Enabled := False;

    BtnStart.Caption := 'RUN';

end;

procedure TMainForm.CBTopClick(Sender: TObject);
begin
    if CBTop.Checked=True then
    begin
      FormTop := 1;
      //BtnTop.Caption := 'NOR';
      SetWindowPos(MainForm.Handle,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE or SWP_NOSIZE);
    end
    else if CBTop.Checked=False then
    begin
      FormTop := 0;
      //BtnTop.Caption := 'TOP';
      SetWindowPos(MainForm.Handle,HWND_NOTOPMOST,0,0,0,0,SWP_NOMOVE or SWP_NOSIZE);
    end;
end;

procedure TMainForm.CBTopKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    CaptureKey( Key);
end;

procedure TMainForm.CBMuteKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    CaptureKey( Key);
end;

end.
